/*******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ******************************************************************************/
package com.example.msb.client;


import java.util.Map.Entry;

import com.example.msb.client.widget.MultivalueSuggestBox;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class MultivalueSuggestBoxExample implements EntryPoint
{

    /**
     * This is the entry point method.
     */
    public void onModuleLoad()
    {
        final Button sendButton = new Button("Show Values");
        
        final MultivalueSuggestBox multivalueField = new MultivalueSuggestBox("/multivaluesuggestboxexample/colors", true);

        final Label valueLabel = new Label();
        final HTML valueHtml = new HTML();
        
        // Add the controls to the RootPanel
        // Use RootPanel.get() to get the entire body element
        RootPanel.get("multivalueFieldContainer").add(multivalueField);
        RootPanel.get("sendButtonContainer").add(sendButton);
        RootPanel.get("valuesContainer").add(valueLabel);
        RootPanel.get("valueMapContainer").add(valueHtml);
        
        multivalueField.setFocus(true);
        
        
        sendButton.addClickHandler(new ClickHandler() {
            
            @Override
            public void onClick(ClickEvent event)
            {
                valueLabel.setText("MultivalueSuggestBox values: " + multivalueField.getValue());
                String html = "";
                for (Entry<String, String> entry : multivalueField.getValueMap().entrySet()) {
                    html += "<div style=\"background-color: " + entry.getValue() + "\">" + entry.getKey() + ": " + entry.getValue() + "</div>";
                }
                valueHtml.setHTML(html);
            }
        });

    }
}
